# -*- coding: iso_8859_1 -*-

from aspylib import astro
import numpy as np
import matplotlib.pyplot as plt

#------------------------------------------------------------------------------------
#	purpose
#------------------------------------------------------------------------------------
#
#	This script is an example showing how to modify a single FITS image and save the modified image under a different name.
#	In this particular example, the user is invited to select a rectangle in the image. Then in the selected area all the pixel levels are replaced with the median value of the whole image.
#	This script can be used to make a cosmetic correction (i.e. remove a cosmic ray impact on one image).
#
#------------------------------------------------------------------------------------
#	input parameters
#------------------------------------------------------------------------------------

Folder = u"C:\\images\\"
Image = Folder + "image_in.fit"
Image2 = Folder + "image_out.fit"

#------------------------------------------------------------------------------------
#	cosmetic correction on input image
#------------------------------------------------------------------------------------

#------- loading image + headers ------
im = astro.get_imagedata([Image])
headerdict = astro.get_headers([Image], text_display=False)

#------ selecting area to be corrected ------
astro.display(im)
print
print 'Specify boundaries of area to be removed from the image'
xmin = np.float32(raw_input('x boundaries (vertical): xmin = '))
xmax = np.float32(raw_input('x boundaries (vertical): xmax = '))
ymin = np.float32(raw_input('y boundaries (horizontal): ymin = '))
ymax = np.float32(raw_input('y boundaries (horizontal): ymax = '))

#------ implementing correction and displaying new image ------
med = astro.get_median(im)
im[xmin:xmax, ymin:ymax] = med
plt.close()
astro.display(im)

#------ saving corrected image -----
astro.save_imagelist(im, headerdict, [Image2])
print
print Image2, "saved"

raw_input("Press ENTER to close")