# -*- coding: iso_8859_1 -*-

from aspylib import calib

#------------------------------------------------------------------------------------
#	purpose
#------------------------------------------------------------------------------------
#
#	This script loads a list of raw images and calibration frames (dark and flat).
#	Then it calibrates the images, co-aligns and co-adds them with the specified method
#	(here: mean co-addition is used, which is the default option of the calib.calibrate_coalign_coadd_and_save() function).
#
#------------------------------------------------------------------------------------
#	input parameters
#------------------------------------------------------------------------------------

#--- folders ---
Folder = u"C:\\sources\\"
Folder_bis = u"C:\\processed\\"

#--- input frames ---
Imagelist = [Folder + "images\\ngc7635-" + str(i+1) + ".fit" for i in range(30)]
Darklist = [Folder + "dark\\dark-" + str(i+1) + ".fit" for i in range(20)]
Flat = Folder_bis + "flat.fit"

#--- output frames ---
final_Image = Folder_bis + "images\\ngc7635-final.fit"

#--- others ---
mult = 10

#--- additional information (for FITS headers) ---
Config = 0
More_headers = {'OBJECT': ['ngc7635 (coadded)','']}

#------------------------------------------------------------------------------------
#	calculations
#------------------------------------------------------------------------------------

calib.calibrate_coalign_coadd_and_save(Imagelist, Darklist, Flat, mult, final_Image, Config, Headers=More_headers)

raw_input("Press ENTER to close")
