# -*- coding: iso_8859_1 -*-

from aspylib import astro
import matplotlib.pyplot as plt

#------------------------------------------------------------------------------------
#	Purpose = calculate the shifts of successive images
#------------------------------------------------------------------------------------
#
#	This script calculates the (dx,dy) shifts of each image in a series with respect to the first image
#
#------------------------------------------------------------------------------------
#	Input parameters
#------------------------------------------------------------------------------------

Folder = u"C:\\images\\"
Imagelist = [Folder + "images-calibrated-" + str(i+1) + ".fit" for i in range(30)]

detection_area = 12		#+/-size of square footprint used for star detection
nb_stars = 12

#------------------------------------------------------------------------------------
#	Script starts here
#------------------------------------------------------------------------------------
images = astro.get_imagedata(Imagelist)

dx = []
dy = []

stars0 = astro.find_stars_accurate(images[0,30:,:], nb_stars, detection_area)

print
print 1, 0., 0.
for i in range(1,len(Imagelist)):
	starsi = astro.find_stars_accurate(images[i,30:,:], nb_stars, detection_area)
	ddx, ddy = astro.find_shift_stars_matching(stars0 ,starsi)
	dx.append(ddx)
	dy.append(ddy)
	print i+1, ddx, ddy

plt.figure()
plt.plot(dx,dy)
plt.grid()
plt.show()
raw_input('Press Enter to close')
