# -*- coding: iso_8859_1 -*-

from aspylib import astro
import numpy as np

#------------------------------------------------------------------------------------
#	Purpose = find Julian dates for a series of images
#------------------------------------------------------------------------------------
#
#	This script reads the "DATE-OBS" headers of a series of images.
#	Then it calculates the corresponding Julian dates and write them in a text file.
#
#------------------------------------------------------------------------------------
#	Input parameters
#------------------------------------------------------------------------------------

Folder = u"C:\\images\\"
Imagelist = [Folder + "images-calibrated-" + str(i+1) + ".fit" for i in range(50)]

#------------------------------------------------------------------------------------
#	Script
#------------------------------------------------------------------------------------

Dateobs = astro.julian_day(astro.get_headervalues(Imagelist, 'DATE-OBS'))

f = open(Folder + 'JJ_dates.txt','w')
for dd in Dateobs:
	f.write(str(dd)+'\n')
f.close()

raw_input("Press ENTER to close")

