# -*- coding: iso_8859_1 -*-

from aspylib import cdr, astro
import numpy as np
import matplotlib.pyplot as plt

#------------------------------------------------------------------------------------
#	Purpose
#------------------------------------------------------------------------------------
#
#	Reads a list of lightcurve files (with CourbRot format) and makes plots showing the measurements.
#	The options of the function cdr.plot_magdata() allow to control the title of the plots, the vertical scales and the color of the plotted curves.
#
#------------------------------------------------------------------------------------
#	Input parameters
#------------------------------------------------------------------------------------

#--- input files ---
Folder = u"C:\\Mesures\\"
Filelist = ["File_1.txt", \
			"File_2.txt", \
			"File_3.txt"]

Filelist = [Folder + x for x in Filelist]

#------------------------------------------------------------------------------------
#	Script
#------------------------------------------------------------------------------------

alldata = cdr.load_magdata(Filelist, zero_mean=False)
cdr.plot_magdata(alldata[:2], 'Target (19 Mar 2012)', dmag=0.4)
cdr.plot_magdata(alldata[2:4], 'Target (24 Mar 2012)', dmag=0.4, dcolor=2)
cdr.plot_magdata(alldata[4:6], 'Target (27 Mar 2012)', dmag=0.4, dcolor=4)
