# -*- coding: iso_8859_1 -*-

import numpy as np
import platform as pf
from ctypes import *

def matching_pairs(stars, trans, distcrit):

	#distcrit is the distance in pixels used as the criterion
	
	c_double_p = POINTER(c_double)

	x1 = stars[:,0].astype(np.double)
	x1p = x1.ctypes.data_as(POINTER(c_double_p))

	y1 = stars[:,1].astype(np.double)
	y1p = y1.ctypes.data_as(POINTER(c_double_p))

	x2 = trans[:,0].astype(np.double)
	x2p = x2.ctypes.data_as(POINTER(c_double_p))

	y2 = trans[:,1].astype(np.double)
	y2p = y2.ctypes.data_as(POINTER(c_double_p))

	pairs = c_int * max(len(stars),len(trans)) 
	z1=pairs()
	z2=pairs()
	
	dim = c_int()
	
	if pf.system()=='Windows':
		cdll.astrometry.matching_pairs(c_double(distcrit), len(stars),x1p, y1p, len(trans), x2p, y2p, byref(dim), byref(z1), byref(z2))
	elif pf.system()=='Linux':
		mydll = cdll.LoadLibrary("libastro.so")
		mydll.matching_pairs(c_double(distcrit), len(stars),x1p, y1p, len(trans), x2p, y2p, byref(dim), byref(z1), byref(z2))
	
	x = []
	x[:] = z1[:dim.value]
	y = []
	y[:] = z2[:dim.value]

	return np.array(x),np.array(y)
