# -*- coding: iso_8859_1 -*-

from aspylib import astro, conf
import numpy as np

def coalign(images, detection_area=10, nb_stars=12, excl=[], incl=[], text=False):

	images_aligned = np.array(images)
	print
	print 'shifts of image 1 wrt image 1 (vert, hor):', 0., 0.

	stars0 = astro.find_stars_accurate(images[0,:,:], nb_stars, detection_area, excluded=excl, included=incl)
	for i in range(1,len(Imagelist)):

		#calculate shifts
		starsi = astro.find_stars_accurate(images[i,:,:], nb_stars, detection_area, excluded=excl, included=incl)
		dx,dy = astro.find_shift_stars_matching(stars0, starsi, text_display=text)
		print 'shifts of image', str(i+1),' wrt image 1 (vert, hor):', dx, dy

		#shift image
		images_aligned[i,:,:] = astro.translate_Bspline(images[i,:,:], (-dx,-dy), 3)

	return images_aligned

def coalign2(images):

	images_aligned = np.array(images)
	print
	print 'shifts of image 1 wrt image 1 (vert, hor):', 0., 0.

	for i in range(1,len(Imagelist)):

		#calculate shifts
		dx, dy = astro.find_shift_crosscorrelation(images[0,:,:], images[i,:,:])
		print 'shifts of image', str(i+1),' wrt image 1 (vert, hor):', dx, dy

		#shift image
		images_aligned[i,:,:] = astro.translate_Bspline(images[i,:,:], (-dx,-dy), 3)

	return images_aligned

def coalign_and_save(Imagelist, Imagelist2, Config, detection_area=10, nb_stars=12, excl=[], incl=[], text=False, Headers={}):

	#--- loading images ---
	image0 = astro.get_imagedata([Imagelist[0]])	
	print 'shifts of image 1 wrt image 1 (vert, hor):', 0., 0.

	#save image
	headerdict = astro.create_headers(Config, [Imagelist[0]])[0]
	headerdict.update(Headers)
	astro.save_imagelist(image0, [headerdict], [Imagelist2[0]])
	print Imagelist2[0] + ' saved'

	stars0 = astro.find_stars_accurate(image0, nb_stars, detection_area, excluded=excl, included=incl)
	for i in range(1,len(Imagelist)):

		#--- loading images ---
		imagei = astro.get_imagedata([Imagelist[i]])	

		#calculate shifts
		starsi = astro.find_stars_accurate(imagei, nb_stars, detection_area, excluded=excl, included=incl)
		dx,dy = astro.find_shift_stars_matching(stars0, starsi, text_display=text)
		print 'shifts of image', str(i+1),' wrt image 1 (vert, hor):', dx, dy

		#shift image
		imagei_aligned = astro.translate_Bspline(imagei, (-dx,-dy), 3)

		#save image
		headerdict = astro.create_headers(Config, [Imagelist[i]])[0]
		headerdict.update(Headers)
		astro.save_imagelist(imagei_aligned, [headerdict], [Imagelist2[i]])
		print Imagelist2[i] + ' saved'
	#-------------------------------------

def coalign2_and_save(Imagelist, Imagelist2, Config, Headers={}):

	#--- loading images ---
	image0 = astro.get_imagedata([Imagelist[0]])
	print 'shifts of image 1 wrt image 1 (vert, hor):', 0., 0.
	
	#save image
	headerdict = astro.create_headers(Config, [Imagelist[0]])[0]
	headerdict.update(Headers)
	astro.save_imagelist(image0, [headerdict], [Imagelist2[0]])
	print Imagelist2[0] + ' saved'

	for i in range(1,len(Imagelist)):

		#--- loading images ---
		imagei = astro.get_imagedata([Imagelist[i]])	

		#calculate shifts
		dx, dy = astro.find_shift_crosscorrelation(image0, imagei)
		print 'shifts of image', str(i+1),' wrt image 1 (vert, hor):', dx, dy

		#shift image
		imagei_aligned = astro.translate_Bspline(imagei, (-dx,-dy), 3)

		#save image
		headerdict = astro.create_headers(Config, [Imagelist[i]])[0]
		headerdict.update(Headers)
		astro.save_imagelist(imagei_aligned, [headerdict], [Imagelist2[i]])
		print Imagelist2[i] + ' saved'
	#-------------------------------------
