# -*- coding: iso_8859_1 -*-

from aspylib import astro, conf
import numpy as np

def find_hotpixels(dark, target_nb):

	y,x = np.meshgrid(np.arange(1,np.shape(dark)[1]+1),np.arange(1,np.shape(dark)[0]+1))
	test = (x>1)*(x<np.shape(dark)[0])*(y>1)*(y<np.shape(dark)[1])

	th1 = np.mean(dark.flatten())
	hotpixels = (dark> th1)* test
	nb1 = np.sum(hotpixels.flatten())
	
	th2 = 10000
	hotpixels = (dark> th2)* test
	nb2 = np.sum(hotpixels.flatten())
	
	while True:
		th3 = th1*0.75+th2*0.25
		hotpixels = (dark> th3)* test
		nb3 = np.sum(hotpixels.flatten())
		
		if nb3>target_nb*2.:
			th1 = th3
			nb1 = nb3
		elif nb3<target_nb*0.5:
			th2 = th3
			nb2 = nb3
		else:
			break

	return hotpixels
	
def save_serie(images, destination_Imagelist, header_Imagelist, Config, Headers={}):

	for i in range(0,len(header_Imagelist)):

		#------ 
		headerdict = astro.create_headers(Config, [header_Imagelist[i]])[0]
		headerdict.update(Headers)
		astro.save_imagelist(images[i,:,:], [headerdict], [destination_Imagelist[i]])
		print destination_Imagelist[i] + ' saved'
	#-------------------------------------
