# -*- coding: iso_8859_1 -*-
"""
	module where aspylib settings are defined.
"""

from aspylib import license
import numpy as np
import platform as pf

#------------------------------------------------------------------------------------------
#	constants
#------------------------------------------------------------------------------------------

saturation = 32767.		#is updated when an image is loaded

def update_saturation(newsat):
	#--- updating constants --
	global saturation
	saturation = newsat

sep = '\\'
if pf.system()=='Linux':
	sep = "/"

cmd = "C:\\WINDOWS\\system32\\cmd.exe"
if pf.system()=='Linux':
	cmd = ""

#color for plotting
col = ['b', 'g', 'r', 'c', 'm', 'y', 'k', '#00FF26', '#FEAE02', '0.8', '0.5', '#006FFF', '#FE80F5', '#BE0D00', '#F3EB00', '#FF2E89']
ind = [0,11,3,7,1,5,14,8,2,15,12,4,13,6,10,9]
col2 = [col[i] for i in ind]
del ind

#------------------------------------------------------------------------------------------
#	default headers
#------------------------------------------------------------------------------------------

def set_headers(Config):

	#depending on Config, the Python dictionary hd will contain different headers
	# - headers like 'BINX':[] mean that the header will be taken from an existing image when calling astro.create_headers
	# - headers like 'CAMERA':['Audine','Data acquisition camera'] will be directly used like this when calling astro.create_headers

	hd = {}
	
	if Config == 0: 	#just leave following headers unchanged
		hd = {'BINX':[],'BINY':[],'BIN1':[],'BIN2':[],'DATE-OBS':[],'DATE-END':[],'EXPTIME':[],'EXPOSURE':[],'GPS-DATE':[],'OBJECT':[]}

	if Config == 1: 	#Audine KAF0400 + Visac with focal reducer
		hd = {'BINX':[],'BINY':[],'BIN1':[],'BIN2':[],'DATE-OBS':[],'DATE-END':[],'EXPTIME':[],'EXPOSURE':[],'GPS-DATE':[],'OBJECT':[]}
	
		hd.update({'OBSERVER':	['Jerome CARON','Observer name']})
		hd.update({'ORIGIN':		['Uiterstegracht, Leiden, Netherlands','Origin place of FITS file']})
		hd.update({'SITELAT':		['52:09:26.6 North','Latitude where data acquisition was made']})
		hd.update({'SITELONG':	['04:29:51.9 East','Longitude where data acquisition was made']})

		hd.update({'CAMERA':		['Audine Kaf0402-ME','Data acquisition camera']})

		hd.update({'TELESCOP':	['Vixen VISAC VC200L + focal reducer','Data acquisition telescope']})
		hd.update({'DIAMETER':	[200.,'Telescope aperture diameter (mm)']})
		hd.update({'FOCAL':		[1280.,'Telescope focal length (mm)']})

	return hd
