#include "dll.h"

extern "C"
{
   __declspec(dllexport) int Median(int dim, int dim_x, int dim_y, float* a, float* b)
   {
       //--------------------------------------------------------------------------------
       //   This function calculates the median image from a serie of images
       //   Calculation is performed pixel by pixel
       //--------------------------------------------------------------------------------
       //dim = number of images
       //dim_x = number of pixels in x (vertical) direction on individual images
       //dim_y = number of pixels in y (horizontal) direction on individual images
       //a = serie of input images (single 1D array)
       //b = median image (single 1D array)
       float *buffer = new float[dim];

        for (int i=0; i<dim_x; i++)
        for (int j=0; j<dim_y; j++)
        {
            for (int p=0; p<dim; p++)
                buffer[p] = a[p*dim_x*dim_y + i*dim_y + j];

            b[i*dim_y + j] = median(buffer,dim);
        }
      delete [] buffer;
      return(0);
   }
   __declspec(dllexport) int Median2(int dim, int dim_x, int dim_y, float* a, float* b)
   {
       //--------------------------------------------------------------------------------
       //   This function calculates the median pixel on each image from a serie of images
       //   Calculation is performed image by image
       //--------------------------------------------------------------------------------
       //dim = number of images
       //dim_x = number of pixels in x (vertical) direction on individual images
       //dim_y = number of pixels in y (horizontal) direction on individual images
       //a = serie of input images (single 1D array)
       //b = output median values per images (single 1D array)

        for (int p=0; p<dim; p++)
            b[p] = median(a+p*dim_x*dim_y,dim_x*dim_y);

      return(0);
   }
   __declspec(dllexport) int Median3(int dim, int dim_x, int dim_y, float* a, float* b)
   {
       //--------------------------------------------------------------------------------
       //   This function calculates the median values of each column in a serie of images
       //   Calculation is performed image by image, for each image a 1D array is generated
       //--------------------------------------------------------------------------------
       //dim = number of images
       //dim_x = number of pixels in x (vertical) direction on individual images --> used for median calculation
       //dim_y = number of pixels in y (horizontal) direction on individual images
       //a = serie of input images (single 1D array)
       //b = output median values per images (single 1D array)
       float *buffer = new float[dim_x];

        for (int p=0; p<dim; p++)
        for (int j=0; j<dim_y; j++)
        {
            for (int i=0; i<dim_x; i++)
                    buffer[i] = a[p*dim_x*dim_y + i*dim_y + j];

            b[p*dim_y + j] = median(buffer,dim_x);
        }
        delete [] buffer;
      return(0);
   }

}
