# -*- coding: iso_8859_1 -*-

import numpy as np
from aspylib import conf

def load_shifts(filename):

	#display file name
	file_path = filename.split(conf.sep)
	file_core = file_path[len(file_path)-1]
	print
	print "... loading image shifts from %s ..." % file_core

	#open file and reads data
	f=open(filename, 'r')
	try:
		shifts = []
		imagelist = []
		folder = ''

		i=0
		flag = 0
		notlist = ["\n"]
		for line in f:		
			i+=1
			if i==3:
				folder = line[:-1] + conf.sep
			if flag:
				datalist = line.split('\t')
				if datalist[0][0] not in notlist:
					if datalist[1] == 'ok':
						imagelist.append(folder + datalist[2])
						shifts.append([float(datalist[3]),float(datalist[4])])
			
			if (1-flag):
				if line[:6]=="Image\t":
					flag = 1
	finally:
		f.close()
	return imagelist, np.array(shifts)

def load_imagestats(filename):

	#display file name
	file_path = filename.split(conf.sep)
	file_core = file_path[len(file_path)-1]
	print
	print "... loading image statistics from %s ..." % file_core

	#open file and reads data
	f=open(filename, 'r')
	try:
		imagelist = []
		folder = ''
		minmax = []
		globminmax = []
		bgnd = []
		varbgnd = []

		i=0
		flag = 0
		notlist = ["\n"]
		for line in f:		
			i+=1
			if i==3:
				folder = line[:-1] + conf.sep
			if flag:
				datalist = line.split('\t')
				if datalist[0][0] not in notlist:
					if datalist[1] == 'ok':
						imagelist.append(folder + datalist[2])
						if len(datalist)==10:
							minmax.append([float(datalist[3]),float(datalist[4])])
							bgnd.append([float(datalist[6]),float(datalist[7]),float(datalist[8]),float(datalist[9])])
						elif len(datalist)==17:
							globminmax.append([float(datalist[3]),float(datalist[4])])
							minmax.append([float(datalist[5]),float(datalist[6])])
							bgnd.append([float(datalist[7]),float(datalist[8]),float(datalist[9]),float(datalist[10]),float(datalist[11])])
							varbgnd.append([float(datalist[12]),float(datalist[13]),float(datalist[14]),float(datalist[15]),float(datalist[16])])
			if (1-flag):
				if line[:6]=="Image\t":
					flag = 1
	finally:
		f.close()
	if len(varbgnd)!=0:
		varbgnd = np.array(varbgnd)
		varbgnd -= np.mean(varbgnd,axis=0)
	return imagelist, np.array(globminmax), np.array(minmax), np.array(bgnd), np.array(varbgnd)
